<template>
  <div>
    <div>
<CModal
      title="Modal title"
      size="sm"
      backdrop= true
      :show.sync="smallModal">
      {{ SuccessMsg }}

</CModal>


<CCardBody>
     <h5>Supplier Master</h5>
   
    <CDataTable
      :items="items"
      :fields="fields"
      table-filter
      items-per-page-select
        :items-per-page="15"
      pagination
      hover
      striped
      border
      sorter
     >
 
<!--Adding Customs buttons to each row -->
    <template #show_details="{item}" >
      <CButton size="sm" color="info" class="ml-1"  @click="ShowUpdateModal=true; SelectSupplier(item)"> Update </CButton>
      <CButton size="sm" color="danger" class="ml-1" @click="ShowDeleteModal=true; SelectSupplier(item)" >Delete</CButton>
      <CButton size="sm" color="dark" class="ml-1" @click="ShowDetailsModal=true; SelectSupplier(item)"> Details </CButton>
    </template>

    </CDataTable>
      <CButton size="sm" color="info" class="" @click="ShowAddModal=true"> Add New Supplier</CButton>
  </CCardBody>

 </div>
<div id="overlay" v-if="ShowAddModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">New Supplier Details</h5>
    <button type="button" class="close"  @click="ShowAddModal=false">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-7">
<form action="#" method="POST">


<!-- 
<div class="form-group">
<input type="text" name="supplier_Id" class="form-control form-control-lg" placeholder="Supplier Id" v-model="newSupplier.supplier_Id">
</div> -->

<div class="form-group">
  <label for="supplier_Name">Supplier Name</label>
<input type="text" name="supplier_Name" class="form-control form-control-lg" placeholder="" v-model="newSupplier.supplier_Name">
</div>

<div class="form-group">
  <label for="supplier_Code">Supplier Code</label>
<input type="text" name="supplier_Code" class="form-control form-control-lg" placeholder="" v-model="newSupplier.supplier_Code">
</div>

<div class="form-group">
  <label for="entryDate">Entry Date</label>
<input type="date" name="entryDate" class="form-control form-control-lg" placeholder=""  v-model="newSupplier.entryDate">
</div>

<div class="form-group">
  <label for="supplier_Contact_No">Supplier Contact Number</label>
<input type="text" name="supplier_Contact_No" class="form-control form-control-lg" placeholder=""  v-model="newSupplier.supplier_Contact_No">
</div>

<!-- <div class="form-group">
<input type="text" name="supplier_Status" class="form-control form-control-lg" placeholder="Supplier Type Id"  v-model="newSupplier.supplier_Contact_No">
</div> -->

<div class="form-group">
  
<CButton size="sm" color="info" class=""  @click="ShowAddModal=false;addSupplier();" > Add Supplier </CButton>
</div>

</form>
 </div>
</div>
</div>
 </div>

 

<!-- Show Details Modal -->
<div id="overlay" v-if="ShowDetailsModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Supplier Details</h5>
    <button type="button" class="close"  @click="ShowDetailsModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
<div class="modal-body p-4">

<form action="#" method="POST">
<div class="form-group">
    <label for="supplier_Id">Supplier Id</label>
<input type="text" label ="Id" name="supplier_Id" readonly class="form-control form-control-lg" placeholder= "Supplier Id" v-model="CurrentSupplier.supplier_Id">
</div>

<div class="form-group">
   <label for="supplier_Name">Supplier Name</label>
<input type="text" name="supplier_Name" readonly class="form-control form-control-lg" placeholder="Supplier Name" v-model="CurrentSupplier.supplier_Name">
</div>

<div class="form-group">
   <label for="supplier_Code">Supplier Code</label>
<input type="text" name="supplier_Code" readonly class="form-control form-control-lg" placeholder="Supplier Code" v-model="CurrentSupplier.supplier_Code">
</div>

<div class="form-group">
   <label for="entryDate">Entry Date</label>
<input type="text" name="entryDate" readonly class="form-control form-control-lg" placeholder="Entry Date"  v-model="CurrentSupplier.entryDate">
</div>

<!-- <div class="form-group">
   <label for="supplier_Status">Supplier Status</label>
<input type="text" name="supplier_Status" readonly class="form-control form-control-lg" placeholder="Supplier Status"  v-model="CurrentSupplier.supplier_Status">
</div> -->



<div class="form-group">
<button class="btn btn-info btn-block btn-lg"  @click="ShowDetailsModal=false;" > Close </button>
</div>
</form>

</div>
</div>
</div>
</div>


  

<!-- Show Update Modal -->
<div id="overlay" v-if="ShowUpdateModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Update Supplier</h5>
    <button type="button" class="close"  @click="ShowUpdateModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<form action="#" method="POST">
<div class="form-group">
 
   <label for="supplier_Id">Supplier Id</label>
<input type="text" name="supplier_Id"  readonly class="form-control form-control-lg" placeholder="Supplier Id" v-model="CurrentSupplier.supplier_Id">
</div>

<div class="form-group">
   <label for="supplier_Name">Supplier Name</label>
   
<input type="text" name="supplier_Name" class="form-control form-control-lg" placeholder="Supplier Name" v-model="CurrentSupplier.supplier_Name">
</div>

<div class="form-group">
   <label for="supplier_Code">Supplier Code</label>
<input type="text" name="supplier_Code" class="form-control form-control-lg" placeholder="Supplier Code" v-model="CurrentSupplier.supplier_Code">
</div>

<div class="form-group">
   <label for="entryDate">Entry Date</label>
<input type="date" name="entryDate" class="form-control form-control-lg" placeholder="Entry Date"  v-model="CurrentSupplier.entryDate">
</div>

<!-- <div class="form-group">
<input type="text" name="supplier_Status" class="form-control form-control-lg" placeholder="Supplier Status"  v-model="CurrentSupplier.supplier_Status">
</div> -->

<div class="form-group">
<button class="btn btn-info btn-block btn-lg"  @click="ShowUpdateModal=false;UpdateSupplier();" > Update Supplier </button>
</div>
</form>

</div>
</div>
</div>
</div>


<!-- Delete Modal -->
<div id="overlay" v-if="ShowDeleteModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Delete Supplier</h5>
    <button type="button" class="close"  @click="ShowDeleteModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<h4 class="text-danger"> Are you sure want to delete the Supplier ? </h4>
<h5> You are deleting {{ this.CurrentSupplier.supplier_Name +' || '+ this.CurrentSupplier.supplier_Code }}</h5>
<hr>
<button class="btn btn-danger btn-lg" @click="ShowDeleteModal=false; deleteSupplier();getAllSupplierDetails()  "> Yes </button>
&nbsp;&nbsp;&nbsp;&nbsp;  
<button class="btn btn-success btn-lg" @click="ShowDeleteModal=false"> No </button>
</div>
</div>
</div>
</div>
</div>
</template>

<script>
const apiurl =  'FGS_FIFO_Supplier_Master/'
const items = [
  { key: 'supplier_Id',  },
  { key: 'supplier_Name', },
  { key: 'supplier_Code', },
  { key: 'entryDate',    },
  { key: 'supplier_Contact_No',     _style: 'width:1%',  },
  //  { key: 'supplier_Status' ,  _style: 'width:1%',},
 ]    
import Vue from 'vue'
import axios from 'axios'
import VUEAxios from 'vue-axios'
Vue.use(VUEAxios,axios)


export default {
  data ()
  {
     return {
     items: items.map((item,) => { return {...item,}}),
     fields: [
              { key: 'supplier_Id' , label: 'Id',},
              { key: 'supplier_Name', label: 'Name', },
              { key: 'supplier_Code', label: 'Code', },
              { key: 'entryDate' , label: 'Entry Date',},
              { key: 'supplier_Contact_No' , label: 'Contact',},
              { key: 'show_details',  label: '',  _style: 'width:35%', }
      
              
      ],
  details: [],
  errMsg:"",
  SuccessMsg:"",
  ShowAddModal:"",
  ShowDeleteModal:"",
  CurrentSupplier:"",
  ShowUpdateModal:"",
  ShowDetailsModal:"",
  smallModal: false,
  newSupplier: {supplier_Id:0,supplier_Name:"",supplier_Code:"",entryDate:0 , supplier_Status : 1}, }
  },



  mounted()
  {
   this.getAllSupplierDetails();
  },

  methods:
  {
   getAllSupplierDetails: function()
   {
    Vue.axios.get(this.$url + apiurl)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.items =response.data.filter(x => x.supplier_Status == 1)
       }
    });
   },

   
  addSupplier()
  {
    if(this.items.find(x => x.supplier_Name == this.newSupplier.supplier_Name &&  x.supplier_Status == this.newSupplier.supplier_Status) || this.items.find(x => x.supplier_Code == this.newSupplier.supplier_Code &&  x.supplier_Status == this.newSupplier.supplier_Status))
    {
     this.SuccessMsg="Material Supplier Name / Code already exist. Please try another ";
     this.smallModal = true;

    }
    else
    {
   Vue.axios.post(this.$url + apiurl,this.newSupplier).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
        this.SuccessMsg ="Record added Successfully.."
        //this.smallModal = true;
        this.getAllSupplierDetails();
        location.reload();
       }
    })
    }
   },

  UpdateSupplier()
  {
  
    Vue.axios.put(this.$url + apiurl +this.CurrentSupplier.supplier_Id,this.CurrentSupplier,).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
         this.SuccessMsg ="Records Updated Successfully.."
         this.getAllSupplierDetails();
       }
    })
   },

  deleteSupplier()
    {
      var supplier_Id = this.CurrentSupplier.supplier_Id;
        axios({   method: 'delete',
        url: this.$url + apiurl + supplier_Id
    });   
        this.SuccessMsg="Supplier Status of "+supplier_Id+" Changed to Inactive Succesfully"
        this.getAllSupplierDetails();
    },
      
  SelectSupplier(Supplier)
    {
     this.CurrentSupplier=Supplier;
    },
    

  },

}
</script>

<style scoped>
#overlay{
  position:absolute;
  top:100px;
  bottom:0;
  left:0;
  right:0;
  background:rgba(0,0,0,0.6);
}
</style>